package mvd.jester;

import java.util.Arrays;
import java.util.Set;
import mvd.jester.model.DagTask;
import mvd.jester.model.SystemSetup;
import mvd.jester.tests.AbstractTest;
import mvd.jester.tests.FonsecaNelis;
import mvd.jester.tests.SchmidMottok;


/**
 * Hello world!
 *
 */
public class App {
    public static void main(String[] args) {
        for (int p = 8; p <= 8; p *= 2) {
            SystemSetup.DagTaskBuilder builder =
                    new SystemSetup.DagTaskBuilder().setNumberOfProcessors(p);
            TestEnvironment te = new TestEnvironment();

            Set<ResultCollector<AbstractTest<DagTask>>> tests = te.registerTests(Arrays
                    .asList(new SchmidMottok(p), /* new MelaniButtazzo(p), */ new FonsecaNelis(p)));

            te.runExperiments(builder, tests, p, 500);
        }
    }
}
