package mvd.jester.simulator;

import mvd.jester.model.SystemSetup;
import mvd.jester.model.SynchronousTask;
import mvd.jester.simulator.internals.parallelsynchronous.TaskContext;

/**
 * MaiaBertogna
 */
public class ParallelSynchronous extends AbstractSimulator {

    public ParallelSynchronous(SystemSetup<SynchronousTask> systemSetup) {
        super(systemSetup);
    }

    @Override
    protected boolean releaseTasks(long timeStep) {
        for (SynchronousTask t : systemSetup.getTasks()) {
            if (timeStep % t.getPeriod() == 0) {
                TaskContext tc = new TaskContext(t, timeStep);
                if (!readyTasks.add(tc)) {
                    EventPrinter
                            .print("Time " + timeStep + ": Task " + tc + " could not be released!");
                    return false;
                }
                EventPrinter.print("Time " + timeStep + ": Task " + tc + " released!");
            }
        }
        return true;
    }

    @Override
    public String getName() {
        return "MaiaBertogna";
    }


}
